function [ L ] = L_Matrix( M,N,pattern_size)
% function L_Matrix returns the matrix L which is a matrix such that Lz 
% is a vector with finite-difference approximations
% of the directional derivatives across the block boundaries.
% L is used to penalize the block artifacts in the reconstruction
% formulation
% Copyright (C) Sara Soltani and Technical University of Denmark, 
% August 2015, ssol@dtu.dk, sarahsoltani@gmail.com

L=[];
for j=1:(N/pattern_size(2))-1
    Unit_vec = zeros(N,1);
    Unit_vec(j*pattern_size(2))=1;
    Unit_vec(j*pattern_size(2)+1)=-1;
    L=[L;kron(Unit_vec',speye(N))];
end
for i=1:(M/pattern_size(1))-1
    Unit_vec = zeros(M,1);
    Unit_vec(i*pattern_size(1))=1;
    Unit_vec(i*pattern_size(1)+1)=-1;
    L=[L;kron(speye(M),Unit_vec')];
end
