function [ P ] = Perm_Vec_Tensor( M,N,pattern_size )

% returns the permutaion vector which gives a permutation to the solution
% vector according to the blocks of size patch_size(1) by patch_size(2)
% in the image for the case when the blocks of the image are computed in 
% Tensor form
% The blocks are stack together and the have a third dimension since they
% are twisted 
%N       % how many pixels are in one rwo of the image-horizental size
%M       % how many pixels are in one column in the image -vertical size
%patch_size(2)      % how many pixels are in one row of the pattren -
                      % horizental size
%patch_size(1)      % how many pixels are in one column of the pattren -
                      % vertical size
                      
% Copyright (C) Sara Soltani and Technical University of Denmark, 
% August 2015, ssol@dtu.dk, sarahsoltani@gmail.com

P=zeros(N*M,1);
counter=1;

while counter<N*M+1
    for i=1:pattern_size(2)
        for k=1:(N/pattern_size(2))
            for j=1:M
                P(counter,1)=(k-1)*pattern_size(2)*M+j+(i-1)*M;
                counter=counter+1;

            end
        end 
    end
 
end
end